100 '*****************************************************************'
110 '*                           P R I N T B                         *'
120 '*---------------------------------------------------------------*'
130 '*  Task           : makes a subroutine available for sending    *'
140 '*                   strings to a printer and                    *'
150 '*                   registering errors during the output to the *'
160 '*                   printer                                     *'
170 '*  Author         : MICHAEL TISCHER                             *'
180 '*  developed on   : 7/22/87                                     *'
190 '*  last update    : 9/21/87                                     *'
200 '*****************************************************************'
210 '
220 CLS : KEY OFF
230 PRINT"WARNING: This program should be started only if GWBASIC was "
240 PRINT"started from the DOS level with <GWBASIC  /m60000>."
250 PRINT : PRINT"If this is not the case, please input <s> for Stop."
260 PRINT"Otherwise press any key...";
270 A$ = INKEY$ : IF A$ = "s" THEN END
280 IF A$ = "" THEN 270
290 GOSUB 60000              'install Function for Interrupt-Call 
300 CLS                      'Clear Screen
310 PRINT"PRINT (c) 1987 by Michael Tischer" : PRINT
320 PRINT"If a parallel printer is interfaced to your PC, the "
330 PRINT"following text should appear on it immediately:" : PRINT
340 PRINT"a test of the printer routines..." : PRINT
350 PRINT"If not, an error message will be output." : PRINT
360 PRINTER% = 0             'address the first Printer on the PC
370 GOSUB 50000              'initialize Printer
380 GOSUB 53000              'output message
390 T$ = "a test of the printer routines..."+CHR$(13)+CHR$(10)
400 GOSUB 51000              'output String on the Printer
410 GOSUB 53000              'output Message 
420 PRINT
430 END
440 '
50000 '***************************************************************'
50010 '* initialize one of the Printer interfaces                    *'
50020 '*-------------------------------------------------------------*'
50030 '* Input: PRINTER% = the Number of the Printer to be addressed *'
50040 '* Output: DS% is the Status of the Printer                    *'
50050 '* Info   : the Variable Z% is used as Dummy                   *'
50060 '***************************************************************'
50070 '
50080 PRTHI% = 0             'Hi-Byte of the Printer number
50090 FKT%=2                 'initialize Function number for Interface 
50100 INR%=&H17              'call BIOS-Printer-Interrupt 17(h) 
50110 CALL IA(INR%,FKT%,Z%,Z%,Z%,Z%,Z%,PRTHI%,PRINTER%,Z%,Z%,Z%,Z%)
50120 DS% = FKT% AND &H21    'store Printer status in DS% 
50130 RETURN                 'back to Caller
50140 '
51000 '***************************************************************'
51010 '* send a String to one of the Printers                        *'
51020 '*-------------------------------------------------------------*'
51030 '* Input: T$       = the String to be output                   *'
51040 '*          PRINTER% = the Number of the Printer               *'
51050 '* Output: the Variable DS% contains the Printer status        *'
51060 '***************************************************************'
51070 '
51080 FOR I = 1 TO LEN(T$)   'process all characters of the string 
51090 Z$ = MID$(T$,I,1)      'isolate one character from the string 
51100 GOSUB 52000            'output character on the printer 
51110 IF DS%<>0 THEN I = LEN(T$)        'on error terminate output 
51120 NEXT I                 'process next character 
51130 RETURN                 'back to Caller
51140 '
52000 '***************************************************************'
52010 '* send a Character to one of the Printers                     *'
52020 '*-------------------------------------------------------------*'
52030 '* Input: Z$       = the Character to be output                *'
52040 '*          PRINTER% = the Number of the Printer               *'
52050 '* Output: the Variable DS% contains Printer status (0=o.k.)   *'
52060 '* Info   : the Variable Z% is used as a Dummy                 *'
52070 '***************************************************************'
52080 '
52090 CHARACTER% = ASC(Z$)   'the ASCII-Code of the Character
52100 FKT%=0                 'print Function number for Character 
52110 INR%=&H17              'call BIOS-Printer-Interrupt 17(h) 
52120 CALL IA(INR%,FKT%,CHARACTER%,Z%,Z%,Z%,Z%, PRTHI%,PRINTER%,Z%,Z%,Z%,Z%)
52130 DS% = FKT% AND &H21    'record Printer status in DS% 
52140 RETURN                 'back to Caller
52150 '
53000 '***************************************************************'
53010 '* Output an error-message on the basis of the Printer-Status  *'
53020 '*-------------------------------------------------------------*'
53030 '* Input: DS% = the Printer status                             *'
53040 '* Output: none                                                *'
53050 '* Info   : if the Printer status is  o.k., no output          *'
53060 '***************************************************************'
53070 '
53080 IF DS% = 0 THEN RETURN 'everything o.k. --> back to Caller
53090 PRINT"Error on access to Printer: ";
53100 IF (DS% AND 1) <> 0 THEN PRINT"Time-Out-Error" : RETURN
53110 IF (DS% AND 8) <> 0 THEN PRINT"I/O Error" : RETURN
53120 IF (DS% AND 32) <> 0 THEN PRINT"no more paper " : RETURN
53130 PRINT"Error type unknown" : RETURN
53140 '
60000 '***************************************************************'
60010 '* initialize the Routine for Interrupt-Call                   *'
60020 '*-------------------------------------------------------------*'
60030 '* Input: none                                                 *'
60040 '* Output: IA is the Start address of the Interrupt-Routine    *'
60050 '***************************************************************'
60060 '
60070 IA=60000!      'Start address of the Routine in the BASIC-Segment
60080 DEF SEG        'set BASIC-Segment 
60090 RESTORE 60130
60100 FOR I% = 0 TO 160 : READ X% : POKE IA+I%,X% : NEXT  'poke Routine 
60110 RETURN         'back to Caller
60120 '
60130 DATA  85,139,236, 30,  6,139,118, 30,139,  4,232,140,  0,139,118
60140 DATA  12,139, 60,139,118,  8,139,  4, 61,255,255,117,  2,140,216
60150 DATA 142,192,139,118, 28,138, 36,139,118, 26,138,  4,139,118, 24
60160 DATA 138, 60,139,118, 22,138, 28,139,118, 20,138, 44,139,118, 18
60170 DATA 138, 12,139,118, 16,138, 52,139,118, 14,138, 20,139,118, 10
60180 DATA 139, 52, 85,205, 33, 93, 86,156,139,118, 12,137, 60,139,118
60190 DATA  28,136, 36,139,118, 26,136,  4,139,118, 24,136, 60,139,118
60200 DATA  22,136, 28,139,118, 20,136, 44,139,118, 18,136, 12,139,118
60210 DATA  16,136, 52,139,118, 14,136, 20,139,118,  8,140,192,137,  4
60220 DATA  88,139,118,  6,137,  4, 88,139,118, 10,137,  4,  7, 31, 93
60230 DATA 202, 26,  0, 91, 46,136, 71, 66,233,108,255
